#include "callxyzzy.cc"
#include <windows.h>
#include <wininet.h>
#include <stdio.h>
#include <stdlib.h>

#define BUFSIZE 1024*5
const char * hextable="0123456789ABCDEF";

class httpdat
{
private:
  unsigned char buf[BUFSIZE+1];
  unsigned char *convertbuf;
  DWORD size;
  httpdat *next;
public:
  httpdat(){
    next=NULL;
    convertbuf=NULL;
  };
  ~httpdat() {
    if(next!=NULL)
      delete next;
    if(convertbuf!=NULL)
      delete convertbuf;
  }
  int get_size() {
    if (next!=NULL){
      return size + next->get_size();
    } else {
      return size;
    }
  }
  void get_http(char *url){
    if(next!=NULL)
      delete next;
    next=NULL;
    HINTERNET hSession;
    hSession = InternetOpen( "MyApp", INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0 );
    if( hSession ){
      httpdat *p=this;
      HINTERNET hService;
      hService = InternetOpenUrl( hSession,url, NULL, 0, 0, 0 );
      if( hService ){
        while(1){
          p->size=BUFSIZE;
          InternetReadFile( hService, p->buf,BUFSIZE,&(p->size));
          if( p->size == 0 ) break;
          p->buf[p->size] = '\0';
          p->next=new httpdat;
          p=p->next;
        }
      }
      InternetCloseHandle(hService);
    }
    InternetCloseHandle(hSession);
  }
  char* convert(char *head,char *foot) {
    if(convertbuf!=NULL)
      delete convertbuf;
    convertbuf= new unsigned char [lstrlen(head)+lstrlen(foot)+get_size()*4+1];
    unsigned char *p=convertbuf;
    for(int i=0;head[i]!='\0';++i,++p) {
      *p=head[i];
    }
    for(int i=0;i<get_size();++i) {
      unsigned char c = get_char(i);
      *(p++)='\\';
      *(p++)='x';
      *(p++)=hextable[c/16];
      *(p++)=hextable[c%16];
    }
    for(int i=0;foot[i]!='\0';++i,++p) {
      *p=foot[i];
    }
    *p='\0';
    return (char *) convertbuf;
  }
  unsigned char get_char(int index) {
    if(index>size){
      return next->get_char(index-size);
    }else{
      return buf[index];
    }
  }
};


int main(int argc,char **argv)
{
  //1=hwnd
  //2=url
  //3=fname
  httpdat http;
  http.get_http(argv[2]);
  char *p,*d;
  int h=atoi(argv[1]);
  p=d=new char[lstrlen(argv[2])+lstrlen(argv[3])+5];
  //p="(argv[3] \"argv[2]\" \"";
  *d++ = '(';
  d = stpcpy(d,argv[3]);
  d = stpcpy(d," \"");
  d = stpcpy(d,argv[2]);
  d = stpcpy(d,"\" \"");
  *d = 0;
  send_xyzzy((HWND)h,http.convert(p , "\")"));
  delete p;
}
