#include "xyzzycli.cc"

int send_xyzzy (HWND hwnd,char *str)
{
  xyzzysrv sv;
  lookup_server ls;
  if (enum_proc(hwnd,(LPARAM)&ls)==0) {
    int wait_ok = ls.hevent && WaitForSingleObject (ls.hevent, 60000) == WAIT_OBJECT_0;
    CloseHandle (ls.hevent);
    if (!wait_ok){
      return (IDS_CONNECT_FAILED);
    }
    if (!sv.alloc (lstrlen(str)+1))
      return (IDS_NO_MEMORY);
    char *d = stpcpy (sv.data (), str);
    *d = 0;
    int r = SendMessage (ls.hwnd, RegisterWindowMessage (xyzzysrv_name),
                       GetCurrentProcessId (), LPARAM (sv.handle ()));
    if (!r)
      return (IDS_READ_FAILED);
    if (r > 0)
      wait_term (sv);
  }
  return 0;
}

HWND find_xyzzy (void)
{
  lookup_server ls;
  synchronize sync ("{FDFB3F8E-65AC-11D4-ADA0-0040053444B8}");
  return find_server (ls);
}
